using System;
using System.Collections.Generic;
using System.Text;

using System.Data;
using System.Data.SqlClient;
using OOP.Bank.Common;
using OOP.Bank.Interface;

namespace OOP.Bank.DataAccess
{
    public class AccountDac : Configuration
    {
        public static Int32 Create(IBankAccount BankAccount)
        {
            SqlParameter[] _parameters = {                
                new SqlParameter( "@_account_no", BankAccount.AccountNo ),
                new SqlParameter( "@_account_balance", BankAccount.AccountBalance )
            };
            return Convert.ToInt32(SqlHelper.ExecuteScalar(ConnectionString, "_Accounts_Insert", _parameters));
        }

        public static SqlDataReader Retrieve(String _account_no)
        {
            SqlParameter[] _parameters = { new SqlParameter("@_account_no", _account_no) };
            return SqlHelper.ExecuteReader(ConnectionString, "_Accounts_Retrieve", _parameters);
        }

        public static Int32 Update(IBankAccount BankAccount)
        {
            SqlParameter[] _parameters = { 
                new SqlParameter( "@_account_no", BankAccount.AccountNo ),
                new SqlParameter( "@_account_balance", BankAccount.AccountBalance )
            };
            return Convert.ToInt32(SqlHelper.ExecuteScalar(ConnectionString, "_Accounts_Update", _parameters));
        }

        public static DataSet RetrieveList(IBankAccount BankAccount)
        {
            SqlParameter[] _parameters = { new SqlParameter( "@_account_no", BankAccount.AccountNo )};
            return SqlHelper.ExecuteDataset(ConnectionString, "_Customers_Retrieve_All", _parameters);
        }
    }
}
