using System;
using System.Collections.Generic;
using System.Text;

using System.Data;
using System.Data.SqlClient;
using OOP.Bank.Common;
using OOP.Bank.Interface;

namespace OOP.Bank.DataAccess
{
    public class CustomerDac : Configuration
    {
        public static String Create(ICustomer Customer)
        {
            SqlParameter[] _parameters = {                
                new SqlParameter( "@_firstname", Customer.FirstName ),                
                new SqlParameter( "@_lastname", Customer.LastName ),
                new SqlParameter( "@_email", Customer.Email),
                new SqlParameter( "@_password", Customer.Password)
            };
            return Convert.ToString(SqlHelper.ExecuteScalar(ConnectionString, "_Customers_Insert", _parameters));
        }

        public static SqlDataReader Retrieve(String _account_no)
        {
            SqlParameter[] _parameters = { new SqlParameter("@_account_no", _account_no) };
            return SqlHelper.ExecuteReader(ConnectionString, "_Customers_Retrieve", _parameters);
        }

        public static Int32 Delete(ICustomer Customer)
        {
            SqlParameter[] _parameters = { new SqlParameter( "@_account_no", Customer.BankAccount.AccountNo ) };
            return Convert.ToInt32(SqlHelper.ExecuteScalar(ConnectionString, "_Customers_Delete", _parameters));
        }

        public static Int32 Update(ICustomer Customer)
        {
            SqlParameter[] _parameters = {                
                new SqlParameter( "@_account_no", Customer.BankAccount.AccountNo ),
                new SqlParameter( "@_firstname", Customer.FirstName ),                
                new SqlParameter( "@_lastname", Customer.LastName ),
                new SqlParameter( "@_email", Customer.Email)
            };
            return Convert.ToInt32(SqlHelper.ExecuteScalar(ConnectionString, "_Customers_Update", _parameters));
        }

        public static Int32 Login(String AccountNo, String Password)
        {
            SqlParameter[] _parameters = {                
                new SqlParameter( "@_account_no", AccountNo ),
                new SqlParameter( "@_password", Password )
            };
            return Convert.ToInt32(SqlHelper.ExecuteScalar(ConnectionString, "_Customers_Login", _parameters));
        }
    }
}
