using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using OOP.Bank.Business;

public partial class Transfer : System.Web.UI.Page
{
    Account account=new Account();

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            if (Session["AccountNo"] != null)
            {
                String account_no = Convert.ToString(Session["AccountNo"]);

                Account account = new Account(account_no);
                DataSet dsAccounts = account.RetrieveList();
                drpAccountNo.DataSource = dsAccounts;
                drpAccountNo.DataMember = dsAccounts.Tables[0].TableName;
                drpAccountNo.DataTextField = "_account_no";
                drpAccountNo.DataValueField = "_account_no";
                drpAccountNo.DataBind();
            }
        }
    }

    protected void btnSubmit_Click(object sender, EventArgs e)
    {
        if (Session["AccountNo"] != null)
            if (txtAmount.Text.Length > 0 || txtAmount.Text == "0")
            {
                Double amount = Convert.ToDouble(txtAmount.Text);
                String account_no = Convert.ToString(Session["AccountNo"]);
                String recipient = drpAccountNo.SelectedValue;

                Account account = new Account(account_no);
                Int32 result = account.Transfer(recipient, amount);
                if (result == 1)
                {
                    lblStatusMessage.Text = "You successfully transfered " + amount.ToString() + " to " + recipient + ".";
                    lblStatusMessage.Text += Environment.NewLine + "Your available balance is " + account.AccountBalance.ToString() + ".";
                }
                else if (result == 2)
                {
                    Double MaintainingBalance = account.MaintainingBalance;
                    lblStatusMessage.Text = "The transaction cannot be processed.";
                    lblStatusMessage.Text += Environment.NewLine + "The transfer violates the maintaining balance of " + Convert.ToString(MaintainingBalance);
                }
                else
                {
                    lblStatusMessage.Text = "Error encountered while processing transaction.";
                }
            }
    }
}
